blob: 6d5c28c7e0f932987613963070303c13b165cceb [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20while [ -h "${prog}" ]; do
21 newProg=`/bin/ls -ld "${prog}"`
22 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23 if expr "x${newProg}" : 'x/' >/dev/null; then
24 prog="${newProg}"
25 else
26 progdir=`dirname "${prog}"`
27 prog="${progdir}/${newProg}"
28 fi
29done
30oldwd=`pwd`
31progdir=`dirname "${prog}"`
32cd "${progdir}"
33progdir=`pwd`
34prog="${progdir}"/`basename "${prog}"`
35
36run_args=""
37usage="no"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +070038sequental="no"
jeffhao5d1ac922011-09-29 17:41:15 -070039
40while true; do
41 if [ "x$1" = "x--host" ]; then
42 run_args="${run_args} --host"
43 shift
Alex Lighteb7c1442015-08-31 13:17:42 -070044 elif [ "x$1" = "x--use-java-home" ]; then
45 run_args="${run_args} --use-java-home"
46 shift
Alex Lightfadfee92015-10-28 09:40:10 -070047 elif [ "x$1" = "x--no-image" ]; then
48 run_args="${run_args} --no-image"
49 shift
50 elif [ "x$1" = "x--quick" ]; then
51 run_args="${run_args} --quick"
52 shift
53 elif [ "x$1" = "x--optimizing" ]; then
54 run_args="${run_args} --optimizing"
55 shift
56 elif [ "x$1" = "x--image" ]; then
57 run_args="${run_args} --image"
58 shift
59 elif [ "x$1" = "x--never-clean" ]; then
60 run_args="${run_args} --never-clean"
61 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080062 elif [ "x$1" = "x--jvm" ]; then
63 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -070064 shift
jeffhao5d1ac922011-09-29 17:41:15 -070065 elif [ "x$1" = "x--debug" ]; then
66 run_args="${run_args} --debug"
67 shift
Alex Lightfadfee92015-10-28 09:40:10 -070068 elif [ "x$1" = "x--build-only" ]; then
69 run_args="${run_args} --build-only"
70 shift
71 elif [ "x$1" = "x--build-with-jack" ]; then
72 run_args="${run_args} --build-with-jack"
73 shift
74 elif [ "x$1" = "x--build-with-javac-dx" ]; then
75 run_args="${run_args} --build-with-javac-dx"
76 shift
77 elif [ "x$1" = "x--dex2oat-swap" ]; then
78 run_args="${run_args} --dex2oat-swap"
79 shift
80 elif [ "x$1" = "x--dalvik" ]; then
81 run_args="${run_args} --dalvik"
82 shift
83 elif [ "x$1" = "x--debuggable" ]; then
84 run_args="${run_args} --debuggable"
85 shift
jeffhao5d1ac922011-09-29 17:41:15 -070086 elif [ "x$1" = "x--zygote" ]; then
87 run_args="${run_args} --zygote"
88 shift
jeffhao0dff3f42012-11-20 15:13:43 -080089 elif [ "x$1" = "x--interpreter" ]; then
90 run_args="${run_args} --interpreter"
91 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -080092 elif [ "x$1" = "x--jit" ]; then
93 run_args="${run_args} --jit"
94 shift
Alex Lightfadfee92015-10-28 09:40:10 -070095 elif [ "x$1" = "x--verify-soft-fail" ]; then
96 run_args="${run_args} --verify-soft-fail"
97 shift
jeffhao5d1ac922011-09-29 17:41:15 -070098 elif [ "x$1" = "x--no-verify" ]; then
99 run_args="${run_args} --no-verify"
100 shift
101 elif [ "x$1" = "x--no-optimize" ]; then
102 run_args="${run_args} --no-optimize"
103 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700104 elif [ "x$1" = "x--dev" ]; then
105 run_args="${run_args} --dev"
106 shift
107 elif [ "x$1" = "x--update" ]; then
108 run_args="${run_args} --update"
109 shift
110 elif [ "x$1" = "x--help" ]; then
111 usage="yes"
112 shift
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700113 elif [ "x$1" = "x--seq" ]; then
114 sequental="yes"
115 shift
116 elif [ "x$1" = "x-O" ]; then
117 run_args="${run_args} -O"
118 shift
Zheng Xudc8e7322014-05-07 17:07:20 +0100119 elif [ "x$1" = "x--64" ]; then
120 run_args="${run_args} --64"
121 shift
Alex Lighte7873ec2014-08-12 09:53:50 -0700122 elif [ "x$1" = "x--gcstress" ]; then
123 run_args="${run_args} --gcstress"
124 shift
125 elif [ "x$1" = "x--gcverify" ]; then
126 run_args="${run_args} --gcverify"
127 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200128 elif [ "x$1" = "x--trace" ]; then
129 run_args="${run_args} --trace"
130 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700131 elif [ "x$1" = "x--relocate" ]; then
132 run_args="${run_args} --relocate"
133 shift
134 elif [ "x$1" = "x--no-relocate" ]; then
135 run_args="${run_args} --no-relocate"
136 shift
Alex Light9d722532014-07-22 18:07:12 -0700137 elif [ "x$1" = "x--no-prebuild" ]; then
138 run_args="${run_args} --no-prebuild"
139 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700140 elif [ "x$1" = "x--prebuild" ]; then
141 run_args="${run_args} --prebuild"
142 shift;
Alex Light03a112d2014-08-25 13:25:56 -0700143 elif [ "x$1" = "x--no-dex2oat" ]; then
144 run_args="${run_args} --no-dex2oat"
145 shift;
146 elif [ "x$1" = "x--no-patchoat" ]; then
147 run_args="${run_args} --no-patchoat"
148 shift;
Alex Lightbfac14a2014-07-30 09:41:21 -0700149 elif [ "x$1" = "x--always-clean" ]; then
150 run_args="${run_args} --always-clean"
Goran Jakovljevic79829cb2015-03-27 11:48:25 +0100151 shift
Alex Lightfadfee92015-10-28 09:40:10 -0700152 elif [ "x$1" = "x--pic-test" ]; then
153 run_args="${run_args} --pic-test"
154 shift
155 elif [ "x$1" = "x--pic-image" ]; then
156 run_args="${run_args} --pic-image"
157 shift
158 elif [ "x$1" = "x--strace" ]; then
159 run_args="${run_args} --strace"
160 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700161 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700162 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700163 usage="yes"
164 break
165 else
166 break
167 fi
168done
169
170if [ "$usage" = "yes" ]; then
171 prog=`basename $prog`
172 (
173 echo "usage:"
174 echo " $prog --help Print this message."
175 echo " $prog [options] Run all tests with the given options."
176 echo " Options are all passed to run-test; refer to that for " \
177 "further documentation:"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800178 echo " --debug --dev --host --interpreter --jit --jvm --no-optimize"
Alex Lightfadfee92015-10-28 09:40:10 -0700179 echo " --no-verify --verify-soft-fail -O --update --zygote --64"
180 echo " --relocate --prebuild --always-clean --gcstress --gcverify"
181 echo " --trace --no-patchoat --no-dex2oat --use-java-home --pic-image"
182 echo " --pic-test --strace --debuggable --dalvik --dex2oat-swap"
183 echo " --build-only --build-with-jack --build-with-javac-dx"
184 echo " --never-clean --image --no-image --quick --optimizing"
185 echo " --no-relocate --no-prebuild"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700186 echo " Specific Runtime Options:"
187 echo " --seq Run tests one-by-one, avoiding failures caused by busy CPU"
jeffhao5d1ac922011-09-29 17:41:15 -0700188 ) 1>&2
189 exit 1
190fi
191
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700192if [ "$sequental" == "yes" ]; then
193 i=0
194 for test_name in *; do
195 if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
196 ./run-test ${run_args} "$test_name"
197 RES=$?
198 test_pids[i]=i
199 test_names[test_pids[i]]="$test_name"
200 if [ "$RES" != "0" ]; then
201 let failure_count+=1
202 failed_test_names="$failed_test_names ${test_names[i]}"
203 else
204 let succeeded_count+=1
205 fi
206 let i+=1
207 fi
208 done
209else
210 # start all the tests
211 i=0
212 for test_name in *; do
213 if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
214 ./run-test ${run_args} "$test_name" &
215 test_pids[i]=$!
216 test_names[test_pids[i]]="$test_name"
217 let i+=1
218 fi
219 done
jeffhao5d1ac922011-09-29 17:41:15 -0700220
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700221 # wait for all the tests, collecting the failures
222 failure_count=0
223 succeeded_count=0
224 failed_test_names=""
225 for pid in ${test_pids[@]}; do
226 wait $pid
227 if [ "$?" != "0" ]; then
228 let failure_count+=1
229 failed_test_names="$failed_test_names ${test_names[$pid]}[pid=$pid]"
230 else
231 let succeeded_count+=1
232 fi
233 done
234fi
jeffhao5d1ac922011-09-29 17:41:15 -0700235
TDYa127b92bcab2012-04-08 00:09:51 -0700236echo "succeeded tests: $succeeded_count"
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700237echo "failed tests: $failure_count"
238
239for i in $failed_test_names; do
240 echo "failed: $i"
jeffhao5d1ac922011-09-29 17:41:15 -0700241done